/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.18_02 from the
 * contents of Virt.xs. Do not edit this file, edit Virt.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "Virt.xs"
/* -*- c -*-
 *
 * Copyright (C) 2006 Red Hat
 * Copyright (C) 2006-2007 Daniel P. Berrange
 *
 * This program is free software; You can redistribute it and/or modify
 * it under either:
 *
 * a) the GNU General Public License as published by the Free
 *   Software Foundation; either version 2, or (at your option) any
 *   later version,
 *
 * or
 *
 * b) the "Artistic License"
 *
 * The file "LICENSE" distributed along with this file provides full
 * details of the terms and conditions of the two licenses.
 */

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <libvirt/virterror.h>
#include <libvirt/libvirt.h>

void	ignoreVirErrorFunc(void * userData, virErrorPtr error) {
  /* Do nothing */
}

SV *
_sv_from_error (virErrorPtr error)
{
    HV *hv;

    hv = newHV ();

    /* Map virErrorPtr attributes to hash keys */
    hv_store (hv, "code", 4, newSViv (error ? error->code : 0), 0);
    hv_store (hv, "domain", 6, newSViv (error ? error->domain : VIR_FROM_NONE), 0);
    hv_store (hv, "message", 7, newSVpv (error ? error->message : "Unknown problem", 0), 0);

    return sv_bless (newRV_noinc ((SV*) hv), gv_stashpv ("Sys::Virt::Error", TRUE));
}


void
_croak_error (virErrorPtr error)
{
    sv_setsv (ERRSV, _sv_from_error (error));

    /* croak does not return, so we free this now to avoid leaking */
    virResetError (error);

    croak (Nullch);
}

void
_populate_constant(HV *href, char *name, int val)
{
    hv_store(href, name, strlen(name), newSViv(val), 0);
}

#define REGISTER_CONSTANT(name, key) _populate_constant(constants, #key, name)

#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#line 81 "Virt.c"

XS(XS_Sys__Virt__open); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__open)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::_open", "name, readonly");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	name = (char *)SvPV_nolen(ST(0));
	int	readonly = (int)SvIV(ST(1));
	virConnectPtr	RETVAL;
#line 76 "Virt.xs"
      if (!strcmp(name, "")) {
	name = NULL;
      }
      if (readonly) {
	RETVAL = virConnectOpenReadOnly(name);
      } else {
	RETVAL = virConnectOpen(name);
      }
      if (!RETVAL) {
	_croak_error(virGetLastError());
      }
#line 110 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt", (void*)RETVAL );



    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_restore_domain); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_restore_domain)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::restore_domain", "con, from");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	const char *	from = (const char *)SvPV_nolen(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::restore_domain() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 95 "Virt.xs"
      if((virDomainRestore(con, from)) < 0) {
	_croak_error(virConnGetLastError(con));
      }
#line 148 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_get_version); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_get_version)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::get_version", "con");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
#line 103 "Virt.xs"
      unsigned long version;
#line 170 "Virt.c"
	unsigned long	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::get_version() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 105 "Virt.xs"
      if (virConnectGetVersion(con, &version) < 0) {
	_croak_error(virConnGetLastError(con));
      }
      RETVAL = version;
#line 185 "Virt.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_get_type); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_get_type)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::get_type", "con");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::get_type() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 116 "Virt.xs"
      RETVAL = virConnectGetType(con);
#line 216 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_get_node_info); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_get_node_info)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::get_node_info", "con");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
#line 124 "Virt.xs"
      virNodeInfo info;
#line 238 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::get_node_info() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 126 "Virt.xs"
      if (virNodeGetInfo(con, &info) < 0) {
	_croak_error(virConnGetLastError(con));
      }
      RETVAL = newHV();
      hv_store (RETVAL, "model", 5, newSVpv(info.model, 0), 0);
      hv_store (RETVAL, "memory", 6, newSViv(info.memory), 0);
      hv_store (RETVAL, "cpus", 4, newSViv(info.cpus), 0);
      hv_store (RETVAL, "mhz", 3, newSViv(info.mhz), 0);
      hv_store (RETVAL, "nodes", 5, newSViv(info.nodes), 0);
      hv_store (RETVAL, "sockets", 7, newSViv(info.sockets), 0);
      hv_store (RETVAL, "cores", 5, newSViv(info.cores), 0);
      hv_store (RETVAL, "threads", 7, newSViv(info.threads), 0);
#line 260 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_get_capabilities); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_get_capabilities)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::get_capabilities", "con");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
#line 145 "Virt.xs"
      char *xml;
#line 283 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::get_capabilities() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 147 "Virt.xs"
      if (!(xml = virConnectGetCapabilities(con))) {
	 _croak_error(virConnGetLastError(con));
      }
      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 298 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_get_max_vcpus); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_get_max_vcpus)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::get_max_vcpus", "con, type");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	char *	type = (char *)SvPV_nolen(ST(1));
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::get_max_vcpus() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 160 "Virt.xs"
      if ((RETVAL = virConnectGetMaxVcpus(con, type)) < 0) {
	_croak_error(virConnGetLastError(con));
      }
#line 333 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_get_hostname); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_get_hostname)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::get_hostname", "con");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
#line 170 "Virt.xs"
      char *host;
#line 355 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::get_hostname() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 172 "Virt.xs"
      if ((host = virConnectGetHostname(con)) < 0) {
	_croak_error(virConnGetLastError(con));
      }
      RETVAL = newSVpv(host, 0);
      free(host);
#line 370 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_num_of_domains); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_num_of_domains)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::num_of_domains", "con");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::num_of_domains() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 184 "Virt.xs"
      if ((RETVAL = virConnectNumOfDomains(con)) < 0) {
	_croak_error(virConnGetLastError(con));
      }
#line 404 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_list_domain_ids); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_list_domain_ids)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::list_domain_ids", "con, maxids");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxids = (int)SvIV(ST(1));
#line 195 "Virt.xs"
      int *ids;
      int i, nid;
#line 430 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::list_domain_ids() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 198 "Virt.xs"
      Newx(ids, maxids, int);
      if ((nid = virConnectListDomains(con, ids, maxids)) < 0) {
        Safefree(ids);
	_croak_error(virConnGetLastError(con));
      }
      EXTEND(SP, nid);
      for (i = 0 ; i < nid ; i++) {
	PUSHs(sv_2mortal(newSViv(ids[i])));
      }
      Safefree(ids);
#line 449 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_num_of_defined_domains); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_num_of_defined_domains)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::num_of_defined_domains", "con");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::num_of_defined_domains() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 214 "Virt.xs"
      if ((RETVAL = virConnectNumOfDefinedDomains(con)) < 0) {
	_croak_error(virConnGetLastError(con));
      }
#line 482 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_list_defined_domain_names); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_list_defined_domain_names)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::list_defined_domain_names", "con, maxnames");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1));
#line 225 "Virt.xs"
      char **names;
      int ndom;
      int i;
#line 509 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::list_defined_domain_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 229 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((ndom = virConnectListDefinedDomains(con, names, maxnames)) < 0) {
	Safefree(names);
	_croak_error(virConnGetLastError(con));
      }
      EXTEND(SP, ndom);
      for (i = 0 ; i < ndom ; i++) {
	PUSHs(sv_2mortal(newSVpv(names[i], 0)));
        free(names[i]);
      }
      Safefree(names);
#line 529 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_num_of_networks); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_num_of_networks)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::num_of_networks", "con");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::num_of_networks() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 246 "Virt.xs"
      if ((RETVAL = virConnectNumOfNetworks(con)) < 0) {
	_croak_error(virConnGetLastError(con));
      }
#line 562 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_list_network_names); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_list_network_names)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::list_network_names", "con, maxnames");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1));
#line 257 "Virt.xs"
      char **names;
      int i, nnet;
#line 588 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::list_network_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 260 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((nnet = virConnectListNetworks(con, names, maxnames)) < 0) {
        Safefree(names);
	_croak_error(virConnGetLastError(con));
      }
      EXTEND(SP, nnet);
      for (i = 0 ; i < nnet ; i++) {
	PUSHs(sv_2mortal(newSVpv(names[i], 0)));
	free(names[i]);
      }
      Safefree(names);
#line 608 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_num_of_defined_networks); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_num_of_defined_networks)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::num_of_defined_networks", "con");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::num_of_defined_networks() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 277 "Virt.xs"
      if ((RETVAL = virConnectNumOfDefinedNetworks(con)) < 0) {
	_croak_error(virConnGetLastError(con));
      }
#line 641 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_list_defined_network_names); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_list_defined_network_names)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::list_defined_network_names", "con, maxnames");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1));
#line 288 "Virt.xs"
      char **names;
      int ndom;
      int i;
#line 668 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::list_defined_network_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 292 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((ndom = virConnectListDefinedNetworks(con, names, maxnames)) < 0) {
	Safefree(names);
	_croak_error(virConnGetLastError(con));
      }
      EXTEND(SP, ndom);
      for (i = 0 ; i < ndom ; i++) {
	PUSHs(sv_2mortal(newSVpv(names[i], 0)));
        free(names[i]);
      }
      Safefree(names);
#line 688 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::DESTROY", "con");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::DESTROY() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 309 "Virt.xs"
      virConnectClose(con);
#line 719 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain__create_linux); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain__create_linux)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::_create_linux", "con, xml");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1));
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::_create_linux() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 318 "Virt.xs"
      if (!(RETVAL = virDomainCreateLinux(con, xml, 0))) {
	_croak_error(virConnGetLastError(con));
      }
#line 752 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Domain", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain__define_xml); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain__define_xml)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::_define_xml", "con, xml");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1));
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::_define_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 329 "Virt.xs"
      if (!(RETVAL = virDomainDefineXML(con, xml))) {
	_croak_error(virConnGetLastError(con));
      }
#line 787 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Domain", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain__lookup_by_id); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain__lookup_by_id)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::_lookup_by_id", "con, id");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	int	id = (int)SvIV(ST(1));
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::_lookup_by_id() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 340 "Virt.xs"
      if (!(RETVAL = virDomainLookupByID(con, id))) {
	_croak_error(virConnGetLastError(con));
      }
#line 822 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Domain", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain__lookup_by_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::_lookup_by_name", "con, name");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	const char *	name = (const char *)SvPV_nolen(ST(1));
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::_lookup_by_name() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 351 "Virt.xs"
      if (!(RETVAL = virDomainLookupByName(con, name))) {
	_croak_error(virConnGetLastError(con));
      }
#line 857 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Domain", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain__lookup_by_uuid); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain__lookup_by_uuid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::_lookup_by_uuid", "con, uuid");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	const unsigned char *	uuid = (const unsigned char *)SvPV_nolen(ST(1));
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::_lookup_by_uuid() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 362 "Virt.xs"
      if (!(RETVAL = virDomainLookupByUUID(con, uuid))) {
	_croak_error(virConnGetLastError(con));
      }
#line 892 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Domain", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain__lookup_by_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain__lookup_by_uuid_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::_lookup_by_uuid_string", "con, uuid");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	const char *	uuid = (const char *)SvPV_nolen(ST(1));
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::_lookup_by_uuid_string() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 373 "Virt.xs"
      if (!(RETVAL = virDomainLookupByUUIDString(con, uuid))) {
	_croak_error(virConnGetLastError(con));
      }
#line 927 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Domain", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_id); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_id)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::get_id", "dom");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virDomainPtr	dom;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_id() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 383 "Virt.xs"
      if ((RETVAL = virDomainGetID(dom)) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 962 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_uuid); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_uuid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::get_uuid", "dom");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virDomainPtr	dom;
#line 394 "Virt.xs"
      unsigned char rawuuid[16];
#line 984 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_uuid() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 396 "Virt.xs"
      if ((virDomainGetUUID(dom, rawuuid)) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
      RETVAL = newSVpv((char*)rawuuid, 16);
#line 998 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_uuid_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::get_uuid_string", "dom");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virDomainPtr	dom;
#line 407 "Virt.xs"
      char uuid[36];
#line 1021 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_uuid_string() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 409 "Virt.xs"
      if ((virDomainGetUUIDString(dom, uuid)) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }

      RETVAL = newSVpv(uuid, 0);
#line 1036 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::get_name", "dom");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virDomainPtr	dom;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_name() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 421 "Virt.xs"
      if (!(RETVAL = virDomainGetName(dom))) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 1070 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_suspend); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_suspend)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::suspend", "dom");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::suspend() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 432 "Virt.xs"
      if ((virDomainSuspend(dom)) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 1103 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_resume); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_resume)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::resume", "dom");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::resume() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 441 "Virt.xs"
      if ((virDomainResume(dom)) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 1136 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_save); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_save)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::save", "dom, to");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	to = (const char *)SvPV_nolen(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::save() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 451 "Virt.xs"
      if ((virDomainSave(dom, to)) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 1170 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_get_info); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_info)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::get_info", "dom");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virDomainPtr	dom;
#line 460 "Virt.xs"
      virDomainInfo info;
#line 1192 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_info() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 462 "Virt.xs"
      if (virDomainGetInfo(dom, &info) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
      RETVAL = newHV();
      hv_store (RETVAL, "state", 5, newSViv(info.state), 0);
      hv_store (RETVAL, "maxMem", 6, newSViv(info.maxMem), 0);
      hv_store (RETVAL, "memory", 6, newSViv(info.memory), 0);
      hv_store (RETVAL, "nrVirtCpu", 9, newSViv(info.nrVirtCpu), 0);
      hv_store (RETVAL, "cpuTime", 7, newSViv(info.cpuTime), 0);
#line 1211 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_max_memory); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_max_memory)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::get_max_memory", "dom");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virDomainPtr	dom;
	unsigned long	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_max_memory() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 479 "Virt.xs"
      if (!(RETVAL = virDomainGetMaxMemory(dom))) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 1245 "Virt.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_set_max_memory); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_set_max_memory)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::set_max_memory", "dom, val");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned long	val = (unsigned long)SvUV(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::set_max_memory() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 490 "Virt.xs"
      if (virDomainSetMaxMemory(dom, val) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 1279 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_set_memory); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_set_memory)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::set_memory", "dom, val");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned long	val = (unsigned long)SvUV(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::set_memory() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 500 "Virt.xs"
      if (virDomainSetMemory(dom, val) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 1313 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_get_max_vcpus); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_max_vcpus)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::get_max_vcpus", "dom");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virDomainPtr	dom;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_max_vcpus() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 508 "Virt.xs"
      if (!(RETVAL = virDomainGetMaxVcpus(dom))) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 1346 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_os_type); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_os_type)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::get_os_type", "dom");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virDomainPtr	dom;
#line 519 "Virt.xs"
      char *type;
#line 1368 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_os_type() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 521 "Virt.xs"
      if (!(type = virDomainGetOSType(dom))) {
	 _croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
      RETVAL = newSVpv(type, 0);
      free(type);
#line 1383 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_xml_description)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::get_xml_description", "dom");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virDomainPtr	dom;
#line 533 "Virt.xs"
      char *xml;
#line 1406 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_xml_description() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 535 "Virt.xs"
      if (!(xml = virDomainGetXMLDesc(dom, 0))) {
	 _croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 1421 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_shutdown); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_shutdown)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::shutdown", "dom");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::shutdown() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 547 "Virt.xs"
      if (virDomainShutdown(dom) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 1455 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_reboot); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_reboot)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::reboot", "dom, flags");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags = (unsigned int)SvUV(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::reboot() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 556 "Virt.xs"
      if (virDomainReboot(dom, flags) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 1489 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_undefine); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_undefine)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::undefine", "dom");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::undefine() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 564 "Virt.xs"
      if (virDomainUndefine(dom) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 1522 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_create); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_create)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::create", "dom");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::create() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 572 "Virt.xs"
      if (virDomainCreate(dom) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 1555 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_destroy); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_destroy)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::destroy", "dom_rv");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	dom_rv = ST(0);
#line 580 "Virt.xs"
      virDomainPtr dom;
#line 1579 "Virt.c"
#line 582 "Virt.xs"
      dom = (virDomainPtr)SvIV((SV*)SvRV(dom_rv));
      if (virDomainDestroy(dom) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
      sv_setref_pv(dom_rv, "Sys::Virt::Domain", NULL);
#line 1586 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Domain::DESTROY", "dom_rv");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	dom_rv = ST(0);
#line 592 "Virt.xs"
      virDomainPtr dom;
#line 1610 "Virt.c"
#line 594 "Virt.xs"
      dom = (virDomainPtr)SvIV((SV*)SvRV(dom_rv));
      if (dom) {
	virDomainFree(dom);
      }
#line 1616 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Network__create_xml); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network__create_xml)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Network::_create_xml", "con, xml");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1));
	virNetworkPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::_create_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 608 "Virt.xs"
      if (!(RETVAL = virNetworkCreateXML(con, xml))) {
	_croak_error(virConnGetLastError(con));
      }
#line 1649 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Network", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network__define_xml); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network__define_xml)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Network::_define_xml", "con, xml");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1));
	virNetworkPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::_define_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 619 "Virt.xs"
      if (!(RETVAL = virNetworkDefineXML(con, xml))) {
	_croak_error(virConnGetLastError(con));
      }
#line 1684 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Network", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network__lookup_by_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Network::_lookup_by_name", "con, name");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	const char *	name = (const char *)SvPV_nolen(ST(1));
	virNetworkPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::_lookup_by_name() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 630 "Virt.xs"
      if (!(RETVAL = virNetworkLookupByName(con, name))) {
	_croak_error(virConnGetLastError(con));
      }
#line 1719 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Network", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network__lookup_by_uuid); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network__lookup_by_uuid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Network::_lookup_by_uuid", "con, uuid");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	const unsigned char *	uuid = (const unsigned char *)SvPV_nolen(ST(1));
	virNetworkPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::_lookup_by_uuid() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 641 "Virt.xs"
      if (!(RETVAL = virNetworkLookupByUUID(con, uuid))) {
	_croak_error(virConnGetLastError(con));
      }
#line 1754 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Network", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network__lookup_by_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network__lookup_by_uuid_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Network::_lookup_by_uuid_string", "con, uuid");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virConnectPtr	con;
	const char *	uuid = (const char *)SvPV_nolen(ST(1));
	virNetworkPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::_lookup_by_uuid_string() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 652 "Virt.xs"
      if (!(RETVAL = virNetworkLookupByUUIDString(con, uuid))) {
	_croak_error(virConnGetLastError(con));
      }
#line 1789 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Network", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network_get_uuid); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_get_uuid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Network::get_uuid", "net");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virNetworkPtr	net;
#line 662 "Virt.xs"
      unsigned char rawuuid[16];
#line 1813 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = (virNetworkPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::get_uuid() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 664 "Virt.xs"
      if ((virNetworkGetUUID(net, rawuuid)) < 0) {
	_croak_error(virConnGetLastError(virNetworkGetConnect(net)));
      }
      RETVAL = newSVpv((char*)rawuuid, 16);
#line 1827 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network_get_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_get_uuid_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Network::get_uuid_string", "net");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virNetworkPtr	net;
#line 675 "Virt.xs"
      char uuid[36];
#line 1850 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = (virNetworkPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::get_uuid_string() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 677 "Virt.xs"
      if ((virNetworkGetUUIDString(net, uuid)) < 0) {
	_croak_error(virConnGetLastError(virNetworkGetConnect(net)));
      }

      RETVAL = newSVpv(uuid, 0);
#line 1865 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network_get_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_get_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Network::get_name", "net");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virNetworkPtr	net;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = (virNetworkPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::get_name() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 689 "Virt.xs"
      if (!(RETVAL = virNetworkGetName(net))) {
	_croak_error(virConnGetLastError(virNetworkGetConnect(net)));
      }
#line 1899 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network_get_bridge_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_get_bridge_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Network::get_bridge_name", "net");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virNetworkPtr	net;
#line 700 "Virt.xs"
      char *name;
#line 1921 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = (virNetworkPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::get_bridge_name() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 702 "Virt.xs"
      if (!(name = virNetworkGetBridgeName(net))) {
	 _croak_error(virConnGetLastError(virNetworkGetConnect(net)));
      }
      RETVAL = newSVpv(name, 0);
      free(name);
#line 1936 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_get_xml_description)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Network::get_xml_description", "net");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	virNetworkPtr	net;
#line 714 "Virt.xs"
      char *xml;
#line 1959 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = (virNetworkPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::get_xml_description() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 716 "Virt.xs"
      if (!(xml = virNetworkGetXMLDesc(net, 0))) {
	 _croak_error(virConnGetLastError(virNetworkGetConnect(net)));
      }
      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 1974 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network_undefine); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_undefine)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Network::undefine", "net");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNetworkPtr	net;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = (virNetworkPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::undefine() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 728 "Virt.xs"
      if (virNetworkUndefine(net) < 0) {
	_croak_error(virConnGetLastError(virNetworkGetConnect(net)));
      }
#line 2008 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Network_create); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_create)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Network::create", "net");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNetworkPtr	net;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = (virNetworkPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::create() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 736 "Virt.xs"
      if (virNetworkCreate(net) < 0) {
	_croak_error(virConnGetLastError(virNetworkGetConnect(net)));
      }
#line 2041 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Network_destroy); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_destroy)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Network::destroy", "net_rv");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	net_rv = ST(0);
#line 744 "Virt.xs"
      virNetworkPtr net;
#line 2065 "Virt.c"
#line 746 "Virt.xs"
      net = (virNetworkPtr)SvIV((SV*)SvRV(net_rv));
      if (virNetworkDestroy(net) < 0) {
	_croak_error(virConnGetLastError(virNetworkGetConnect(net)));
      }
      sv_setref_pv(net_rv, "Sys::Virt::Network", NULL);
#line 2072 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Network_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Sys::Virt::Network::DESTROY", "net_rv");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	net_rv = ST(0);
#line 756 "Virt.xs"
      virNetworkPtr net;
#line 2096 "Virt.c"
#line 758 "Virt.xs"
      net = (virNetworkPtr)SvIV((SV*)SvRV(net_rv));
      if (net) {
	virNetworkFree(net);
      }
#line 2102 "Virt.c"
	PUTBACK;
	return;
    }
}

#define REGISTER_CONSTANT(name, key) _populate_constant(constants, #key, name)
#ifdef __cplusplus
extern "C"
#endif
XS(boot_Sys__Virt); /* prototype to pass -Wmissing-prototypes */
XS(boot_Sys__Virt)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        newXSproto("Sys::Virt::_open", XS_Sys__Virt__open, file, "$$");
        newXSproto("Sys::Virt::restore_domain", XS_Sys__Virt_restore_domain, file, "$$");
        newXSproto("Sys::Virt::get_version", XS_Sys__Virt_get_version, file, "$");
        newXSproto("Sys::Virt::get_type", XS_Sys__Virt_get_type, file, "$");
        newXSproto("Sys::Virt::get_node_info", XS_Sys__Virt_get_node_info, file, "$");
        newXSproto("Sys::Virt::get_capabilities", XS_Sys__Virt_get_capabilities, file, "$");
        newXSproto("Sys::Virt::get_max_vcpus", XS_Sys__Virt_get_max_vcpus, file, "$$");
        newXSproto("Sys::Virt::get_hostname", XS_Sys__Virt_get_hostname, file, "$");
        newXSproto("Sys::Virt::num_of_domains", XS_Sys__Virt_num_of_domains, file, "$");
        newXSproto("Sys::Virt::list_domain_ids", XS_Sys__Virt_list_domain_ids, file, "$$");
        newXSproto("Sys::Virt::num_of_defined_domains", XS_Sys__Virt_num_of_defined_domains, file, "$");
        newXSproto("Sys::Virt::list_defined_domain_names", XS_Sys__Virt_list_defined_domain_names, file, "$$");
        newXSproto("Sys::Virt::num_of_networks", XS_Sys__Virt_num_of_networks, file, "$");
        newXSproto("Sys::Virt::list_network_names", XS_Sys__Virt_list_network_names, file, "$$");
        newXSproto("Sys::Virt::num_of_defined_networks", XS_Sys__Virt_num_of_defined_networks, file, "$");
        newXSproto("Sys::Virt::list_defined_network_names", XS_Sys__Virt_list_defined_network_names, file, "$$");
        newXSproto("Sys::Virt::DESTROY", XS_Sys__Virt_DESTROY, file, "$");
        newXSproto("Sys::Virt::Domain::_create_linux", XS_Sys__Virt__Domain__create_linux, file, "$$");
        newXSproto("Sys::Virt::Domain::_define_xml", XS_Sys__Virt__Domain__define_xml, file, "$$");
        newXSproto("Sys::Virt::Domain::_lookup_by_id", XS_Sys__Virt__Domain__lookup_by_id, file, "$$");
        newXSproto("Sys::Virt::Domain::_lookup_by_name", XS_Sys__Virt__Domain__lookup_by_name, file, "$$");
        newXSproto("Sys::Virt::Domain::_lookup_by_uuid", XS_Sys__Virt__Domain__lookup_by_uuid, file, "$$");
        newXSproto("Sys::Virt::Domain::_lookup_by_uuid_string", XS_Sys__Virt__Domain__lookup_by_uuid_string, file, "$$");
        newXSproto("Sys::Virt::Domain::get_id", XS_Sys__Virt__Domain_get_id, file, "$");
        newXSproto("Sys::Virt::Domain::get_uuid", XS_Sys__Virt__Domain_get_uuid, file, "$");
        newXSproto("Sys::Virt::Domain::get_uuid_string", XS_Sys__Virt__Domain_get_uuid_string, file, "$");
        newXSproto("Sys::Virt::Domain::get_name", XS_Sys__Virt__Domain_get_name, file, "$");
        newXSproto("Sys::Virt::Domain::suspend", XS_Sys__Virt__Domain_suspend, file, "$");
        newXSproto("Sys::Virt::Domain::resume", XS_Sys__Virt__Domain_resume, file, "$");
        newXSproto("Sys::Virt::Domain::save", XS_Sys__Virt__Domain_save, file, "$$");
        newXSproto("Sys::Virt::Domain::get_info", XS_Sys__Virt__Domain_get_info, file, "$");
        newXSproto("Sys::Virt::Domain::get_max_memory", XS_Sys__Virt__Domain_get_max_memory, file, "$");
        newXSproto("Sys::Virt::Domain::set_max_memory", XS_Sys__Virt__Domain_set_max_memory, file, "$$");
        newXSproto("Sys::Virt::Domain::set_memory", XS_Sys__Virt__Domain_set_memory, file, "$$");
        newXSproto("Sys::Virt::Domain::get_max_vcpus", XS_Sys__Virt__Domain_get_max_vcpus, file, "$");
        newXSproto("Sys::Virt::Domain::get_os_type", XS_Sys__Virt__Domain_get_os_type, file, "$");
        newXSproto("Sys::Virt::Domain::get_xml_description", XS_Sys__Virt__Domain_get_xml_description, file, "$");
        newXSproto("Sys::Virt::Domain::shutdown", XS_Sys__Virt__Domain_shutdown, file, "$");
        newXSproto("Sys::Virt::Domain::reboot", XS_Sys__Virt__Domain_reboot, file, "$$");
        newXSproto("Sys::Virt::Domain::undefine", XS_Sys__Virt__Domain_undefine, file, "$");
        newXSproto("Sys::Virt::Domain::create", XS_Sys__Virt__Domain_create, file, "$");
        newXSproto("Sys::Virt::Domain::destroy", XS_Sys__Virt__Domain_destroy, file, "$");
        newXSproto("Sys::Virt::Domain::DESTROY", XS_Sys__Virt__Domain_DESTROY, file, "$");
        newXSproto("Sys::Virt::Network::_create_xml", XS_Sys__Virt__Network__create_xml, file, "$$");
        newXSproto("Sys::Virt::Network::_define_xml", XS_Sys__Virt__Network__define_xml, file, "$$");
        newXSproto("Sys::Virt::Network::_lookup_by_name", XS_Sys__Virt__Network__lookup_by_name, file, "$$");
        newXSproto("Sys::Virt::Network::_lookup_by_uuid", XS_Sys__Virt__Network__lookup_by_uuid, file, "$$");
        newXSproto("Sys::Virt::Network::_lookup_by_uuid_string", XS_Sys__Virt__Network__lookup_by_uuid_string, file, "$$");
        newXSproto("Sys::Virt::Network::get_uuid", XS_Sys__Virt__Network_get_uuid, file, "$");
        newXSproto("Sys::Virt::Network::get_uuid_string", XS_Sys__Virt__Network_get_uuid_string, file, "$");
        newXSproto("Sys::Virt::Network::get_name", XS_Sys__Virt__Network_get_name, file, "$");
        newXSproto("Sys::Virt::Network::get_bridge_name", XS_Sys__Virt__Network_get_bridge_name, file, "$");
        newXSproto("Sys::Virt::Network::get_xml_description", XS_Sys__Virt__Network_get_xml_description, file, "$");
        newXSproto("Sys::Virt::Network::undefine", XS_Sys__Virt__Network_undefine, file, "$");
        newXSproto("Sys::Virt::Network::create", XS_Sys__Virt__Network_create, file, "$");
        newXSproto("Sys::Virt::Network::destroy", XS_Sys__Virt__Network_destroy, file, "$");
        newXSproto("Sys::Virt::Network::DESTROY", XS_Sys__Virt__Network_DESTROY, file, "$");

    /* Initialisation Section */

#line 773 "Virt.xs"
    {
      HV *constants;

      virSetErrorFunc(NULL, ignoreVirErrorFunc);

      /* not the 'standard' way of doing perl constants, but a lot easier to maintain */

      constants = perl_get_hv("Sys::Virt::Domain::_constants", TRUE);
      REGISTER_CONSTANT(VIR_DOMAIN_NOSTATE, STATE_NOSTATE);
      REGISTER_CONSTANT(VIR_DOMAIN_RUNNING, STATE_RUNNING);
      REGISTER_CONSTANT(VIR_DOMAIN_BLOCKED, STATE_BLOCKED);
      REGISTER_CONSTANT(VIR_DOMAIN_PAUSED, STATE_PAUSED);
      REGISTER_CONSTANT(VIR_DOMAIN_SHUTDOWN, STATE_SHUTDOWN);
      REGISTER_CONSTANT(VIR_DOMAIN_SHUTOFF, STATE_SHUTOFF);
      REGISTER_CONSTANT(VIR_DOMAIN_CRASHED, STATE_CRASHED);
    }

#line 2204 "Virt.c"

    /* End of Initialisation Section */

    if (PL_unitcheckav)
         call_list(PL_scopestack_ix, PL_unitcheckav);
    XSRETURN_YES;
}

